//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Mon Feb 26 14:36:06 2018
// Version: PolarFire v2.0 12.200.0.20
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// Display_Cntrll
module Display_Cntrll(
    // Inputs
    RESET_N_I,
    SYS_CLOCK_I,
    VIDEO_CLOCK_I,
    back_porch_width_i,
    data_valid_i,
    ddr_rd_video_resolution_i,
    display_control_enable_i,
    frame_buff_addr_i,
    frame_ddr_addr_valid_i,
    front_porch_width_i,
    hsync_width_i,
    read_ack_i,
    read_done_i,
    tot_horz_pixels_i,
    tot_vert_lines_i,
    video_datain_i,
    video_resolution_i,
    vsync_width_i,
    // Outputs
    bytes_to_read_o,
    data_enable_o,
    dg_fifo_empty,
    dg_fifo_full,
    dg_fifo_hemtpy,
    disp_cont_busy_o,
    disp_cont_done_o,
    frame_buff_und_disp_o,
    hactive_o,
    horz_sync_o,
    read_req_o,
    rgb_out_o,
    start_read_addr_o,
    vactive_o,
    vert_sync_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input         RESET_N_I;
input         SYS_CLOCK_I;
input         VIDEO_CLOCK_I;
input  [31:0] back_porch_width_i;
input         data_valid_i;
input  [31:0] ddr_rd_video_resolution_i;
input         display_control_enable_i;
input  [31:0] frame_buff_addr_i;
input         frame_ddr_addr_valid_i;
input  [31:0] front_porch_width_i;
input  [11:0] hsync_width_i;
input         read_ack_i;
input         read_done_i;
input  [11:0] tot_horz_pixels_i;
input  [11:0] tot_vert_lines_i;
input  [23:0] video_datain_i;
input  [31:0] video_resolution_i;
input  [11:0] vsync_width_i;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [15:0] bytes_to_read_o;
output        data_enable_o;
output        dg_fifo_empty;
output        dg_fifo_full;
output        dg_fifo_hemtpy;
output        disp_cont_busy_o;
output        disp_cont_done_o;
output [31:0] frame_buff_und_disp_o;
output        hactive_o;
output        horz_sync_o;
output        read_req_o;
output [23:0] rgb_out_o;
output [31:0] start_read_addr_o;
output        vactive_o;
output        vert_sync_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire   [31:0] back_porch_width_i;
wire   [15:0] bytes_to_read_o_net_0;
wire          data_enable_o_net_0;
wire          data_valid_i;
wire   [31:0] ddr_rd_video_resolution_i;
wire          dg_fifo_empty_net_0;
wire          dg_fifo_full_net_0;
wire          dg_fifo_hemtpy_net_0;
wire          disp_cont_busy_o_net_0;
wire          disp_cont_done_o_net_0;
wire          display_control_enable_i;
wire   [31:0] frame_buff_addr_i;
wire   [31:0] frame_buff_und_disp_o_net_0;
wire          frame_ddr_addr_valid_i;
wire   [31:0] front_porch_width_i;
wire          hactive_o_net_0;
wire          horz_sync_o_net_0;
wire   [11:0] hsync_width_i;
wire          read_ack_i;
wire          read_done_i;
wire          read_req_o_net_0;
wire          RESET_N_I;
wire   [23:0] rgb_out_o_net_0;
wire   [31:0] start_read_addr_o_net_0;
wire          SYS_CLOCK_I;
wire   [11:0] tot_horz_pixels_i;
wire   [11:0] tot_vert_lines_i;
wire          vactive_o_net_0;
wire          vert_sync_o_net_0;
wire          VIDEO_CLOCK_I;
wire   [23:0] video_datain_i;
wire   [31:0] video_resolution_i;
wire   [11:0] vsync_width_i;
wire          disp_cont_busy_o_net_1;
wire          disp_cont_done_o_net_1;
wire          read_req_o_net_1;
wire          data_enable_o_net_1;
wire          horz_sync_o_net_1;
wire          vert_sync_o_net_1;
wire          hactive_o_net_1;
wire          vactive_o_net_1;
wire          dg_fifo_empty_net_1;
wire          dg_fifo_full_net_1;
wire          dg_fifo_hemtpy_net_1;
wire   [31:0] frame_buff_und_disp_o_net_1;
wire   [15:0] bytes_to_read_o_net_1;
wire   [31:0] start_read_addr_o_net_1;
wire   [23:0] rgb_out_o_net_1;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign disp_cont_busy_o_net_1      = disp_cont_busy_o_net_0;
assign disp_cont_busy_o            = disp_cont_busy_o_net_1;
assign disp_cont_done_o_net_1      = disp_cont_done_o_net_0;
assign disp_cont_done_o            = disp_cont_done_o_net_1;
assign read_req_o_net_1            = read_req_o_net_0;
assign read_req_o                  = read_req_o_net_1;
assign data_enable_o_net_1         = data_enable_o_net_0;
assign data_enable_o               = data_enable_o_net_1;
assign horz_sync_o_net_1           = horz_sync_o_net_0;
assign horz_sync_o                 = horz_sync_o_net_1;
assign vert_sync_o_net_1           = vert_sync_o_net_0;
assign vert_sync_o                 = vert_sync_o_net_1;
assign hactive_o_net_1             = hactive_o_net_0;
assign hactive_o                   = hactive_o_net_1;
assign vactive_o_net_1             = vactive_o_net_0;
assign vactive_o                   = vactive_o_net_1;
assign dg_fifo_empty_net_1         = dg_fifo_empty_net_0;
assign dg_fifo_empty               = dg_fifo_empty_net_1;
assign dg_fifo_full_net_1          = dg_fifo_full_net_0;
assign dg_fifo_full                = dg_fifo_full_net_1;
assign dg_fifo_hemtpy_net_1        = dg_fifo_hemtpy_net_0;
assign dg_fifo_hemtpy              = dg_fifo_hemtpy_net_1;
assign frame_buff_und_disp_o_net_1 = frame_buff_und_disp_o_net_0;
assign frame_buff_und_disp_o[31:0] = frame_buff_und_disp_o_net_1;
assign bytes_to_read_o_net_1       = bytes_to_read_o_net_0;
assign bytes_to_read_o[15:0]       = bytes_to_read_o_net_1;
assign start_read_addr_o_net_1     = start_read_addr_o_net_0;
assign start_read_addr_o[31:0]     = start_read_addr_o_net_1;
assign rgb_out_o_net_1             = rgb_out_o_net_0;
assign rgb_out_o[23:0]             = rgb_out_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------display_controller   -   Microsemi:SolutionCore:display_controller:2.0.0
display_controller #( 
        .g_DDR_AXI_AWIDTH                ( 32 ),
        .g_DEPTH_OF_VIDEO_PIXEL_FROM_DDR ( 1 ),
        .g_HALF_EMPTY_THRESHOLD          ( 3840 ),
        .g_HORZ_SYNC_PULSE_POLARITY      ( 1 ),
        .g_INITIAL_LINES_TO_BUFFER       ( 6 ),
        .g_INPUT_VIDEO_DATA_BIT_WIDTH    ( 24 ),
        .g_INPUT_X_W_RES_WIDTH           ( 12 ),
        .g_INPUT_Y_H_RES_WIDTH           ( 12 ),
        .g_SUBSEQUENT_LINES_TO_BUFFER    ( 1 ),
        .g_VERT_SYNC_PULSE_POLARITY      ( 1 ),
        .g_VIDEO_FIFO_AWIDTH             ( 13 ) )
Display_Cntrll_0(
        // Inputs
        .RESET_N_I                 ( RESET_N_I ),
        .SYS_CLOCK_I               ( SYS_CLOCK_I ),
        .VIDEO_CLOCK_I             ( VIDEO_CLOCK_I ),
        .display_control_enable_i  ( display_control_enable_i ),
        .video_datain_i            ( video_datain_i ),
        .data_valid_i              ( data_valid_i ),
        .frame_buff_addr_i         ( frame_buff_addr_i ),
        .frame_ddr_addr_valid_i    ( frame_ddr_addr_valid_i ),
        .read_ack_i                ( read_ack_i ),
        .read_done_i               ( read_done_i ),
        .tot_horz_pixels_i         ( tot_horz_pixels_i ),
        .tot_vert_lines_i          ( tot_vert_lines_i ),
        .video_resolution_i        ( video_resolution_i ),
        .ddr_rd_video_resolution_i ( ddr_rd_video_resolution_i ),
        .back_porch_width_i        ( back_porch_width_i ),
        .front_porch_width_i       ( front_porch_width_i ),
        .hsync_width_i             ( hsync_width_i ),
        .vsync_width_i             ( vsync_width_i ),
        // Outputs
        .disp_cont_busy_o          ( disp_cont_busy_o_net_0 ),
        .disp_cont_done_o          ( disp_cont_done_o_net_0 ),
        .frame_buff_und_disp_o     ( frame_buff_und_disp_o_net_0 ),
        .bytes_to_read_o           ( bytes_to_read_o_net_0 ),
        .start_read_addr_o         ( start_read_addr_o_net_0 ),
        .read_req_o                ( read_req_o_net_0 ),
        .rgb_out_o                 ( rgb_out_o_net_0 ),
        .data_enable_o             ( data_enable_o_net_0 ),
        .horz_sync_o               ( horz_sync_o_net_0 ),
        .vert_sync_o               ( vert_sync_o_net_0 ),
        .hactive_o                 ( hactive_o_net_0 ),
        .vactive_o                 ( vactive_o_net_0 ),
        .dg_fifo_empty             ( dg_fifo_empty_net_0 ),
        .dg_fifo_full              ( dg_fifo_full_net_0 ),
        .dg_fifo_hemtpy            ( dg_fifo_hemtpy_net_0 ) 
        );


endmodule
