// Copyright (c) 2017, Microsemi Corporation
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL MICROSEMI CORPORATIONM BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// APACHE LICENSE
// Copyright (c) 2017, Microsemi Corporation 
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Description:
//
// SVN Revision Information:
// SVN $Revision: $
// SVN $Date: $
//
// Resolved SARs
// SAR      Date     Who   Description
//
// Notes:
//
// ****************************************************************************/
`ifndef RANDOMIZE_REG_INIT 
	 `define RANDOMIZE_REG_INIT 
 `endif
`ifndef RANDOMIZE_MEM_INIT 
	 `define RANDOMIZE_MEM_INIT 
 `endif
`ifndef RANDOMIZE 
	 `define RANDOMIZE 
`endif

`timescale 1ns/10ps
module Mi_V_Processor_0_Mi_V_Processor_0_0_MIV_RV32IMA_L1_AHB_INT_SYNC_CROSSING_SOURCE_2( // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111266.2]
  input   clock, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111267.4]
  input   reset, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111268.4]
  input   auto_in_1_0, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
  input   auto_in_0_0, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
  input   auto_in_0_1, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
  output  auto_out_1_sync_0, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
  output  auto_out_0_sync_0, // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
  output  auto_out_0_sync_1 // @[:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111269.4]
);
  wire  AsyncResetRegVec_w2_i0_clock; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111287.4]
  wire  AsyncResetRegVec_w2_i0_reset; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111287.4]
  wire [1:0] AsyncResetRegVec_w2_i0_io_d; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111287.4]
  wire [1:0] AsyncResetRegVec_w2_i0_io_q; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111287.4]
  wire  AsyncResetRegVec_w1_i0_clock; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111297.4]
  wire  AsyncResetRegVec_w1_i0_reset; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111297.4]
  wire  AsyncResetRegVec_w1_i0_io_d; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111297.4]
  wire  AsyncResetRegVec_w1_i0_io_q; // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111297.4]
  wire [1:0] _T_64; // @[Cat.scala 30:58:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111286.4]
  wire  _T_66; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111293.4]
  wire  _T_67; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111294.4]
  wire  _T_69; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111303.4]
  Mi_V_Processor_0_Mi_V_Processor_0_0_MIV_RV32IMA_L1_AHB_ASYNC_RESET_REG_VEC_W2_I0 MIV_RV32IMA_L1_AHB_ASYNC_RESET_REG_VEC_W2_I0 ( // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111287.4]
    .clock(AsyncResetRegVec_w2_i0_clock),
    .reset(AsyncResetRegVec_w2_i0_reset),
    .io_d(AsyncResetRegVec_w2_i0_io_d),
    .io_q(AsyncResetRegVec_w2_i0_io_q)
  );
  Mi_V_Processor_0_Mi_V_Processor_0_0_MIV_RV32IMA_L1_AHB_ASYNC_RESET_REG_VEC_W1_I0 MIV_RV32IMA_L1_AHB_ASYNC_RESET_REG_VEC_W1_I0 ( // @[AsyncResetReg.scala 90:21:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111297.4]
    .clock(AsyncResetRegVec_w1_i0_clock),
    .reset(AsyncResetRegVec_w1_i0_reset),
    .io_d(AsyncResetRegVec_w1_i0_io_d),
    .io_q(AsyncResetRegVec_w1_i0_io_q)
  );
  assign _T_64 = {auto_in_0_1,auto_in_0_0}; // @[Cat.scala 30:58:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111286.4]
  assign _T_66 = AsyncResetRegVec_w2_i0_io_q[0]; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111293.4]
  assign _T_67 = AsyncResetRegVec_w2_i0_io_q[1]; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111294.4]
  assign _T_69 = AsyncResetRegVec_w1_i0_io_q; // @[Crossing.scala 41:52:freechips.rocketchip.system.MivRV32ImaL1AhbConfig.fir@111303.4]
  assign auto_out_1_sync_0 = _T_69;
  assign auto_out_0_sync_0 = _T_66;
  assign auto_out_0_sync_1 = _T_67;
  assign AsyncResetRegVec_w2_i0_clock = clock;
  assign AsyncResetRegVec_w2_i0_reset = reset;
  assign AsyncResetRegVec_w2_i0_io_d = _T_64;
  assign AsyncResetRegVec_w1_i0_clock = clock;
  assign AsyncResetRegVec_w1_i0_reset = reset;
  assign AsyncResetRegVec_w1_i0_io_d = auto_in_1_0;
endmodule
